config/routes.rb
Rails.application.routes.draw do
  scope '/api', format: :json do
    scope '/v1' do
      resources :companies do
        resources :offices
        resources :employees
        resources :projects
      end
    end
  end
  defaults format: :html do
    root 'home#index'
    get 'home/index'
    get '*path', to: 'home#index'
  end
end

app/models/company.rb
class Company < ApplicationRecord
  has_many :offices, dependent: :destroy
  has_many :employees, dependent: :destroy
  has_many :projects, dependent: :destroy

  validates :name, presence: true, length: { maximum: 100 }
end

app/controllers/companies_controller.rb
class CompaniesController < ApplicationController
  before_action :set_company, only: [:show, :edit, :update, :destroy]

  # GET /companies
  def index
    @companies = Company.all
    render json: @companies, status: :ok
  end

  # GET /companies/1
  def show
    render json: @company, status: :ok
  end

  # GET /companies/new
  def new
    @company = Company.new
    render json: @company, status: :ok
  end

  # GET /companies/1/edit
  def edit
    render json: @company, status: :ok
  end

  # POST /companies
  def create
    @company = Company.new(company_params)

    if @company.save
      render json: @company, status: :created
      # redirect_to @company, notice: t('notice.created')
    else
      render json: { messages: @company.errors.messages }, status: :unprocessable_entity
      # render :new
    end
  end

  # PATCH/PUT /companies/1
  def update
    if @company.update(company_params)
      render json: @company, status: :ok
      # redirect_to @company, notice: t('notice.updated')
    else
      messages = @company.errors.map {|error| [error.attribute.to_s, error.full_message] }.to_h
      render json: { messages: messages }, status: :unprocessable_entity
      # render :edit
    end
  end

  # DELETE /companies/1
  def destroy
    if @company.destroy
      render json: @company, status: :ok
    else
      render json: { messages: @company.errors.messages }, status: :unprocessable_entity
    end
    # redirect_to companies_url, notice: t('notice.destroyed')
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_company
      @company = Company.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def company_params
      params.require(:company).permit(:name)
    end
end

app/views/companies/_form.html.erb
<%= form_with(model: company) do |form| %>
  <% if company.errors.any? %>
    <div id="error_explanation">
      <h2><%= t('errors.template.header.other', model: t('activerecord.models.company'), count: company.errors.count) %></h2>

      <ul>
        <% company.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :name %>
    <%= form.text_field :name %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/companies/edit.html.erb
<% breadcrumb :edit_company, @company %>

<h1><%= t('.') %></h1>

<%= render 'form', company: @company %>

<%= link_to t('show'), @company %> |
<%= link_to t('back'), companies_path %>

app/views/companies/index.html.erb
<% breadcrumb :companies %>

<p id="notice"><%= notice %></p>

<h1><%= t('.') %></h1>

<table>
  <thead>
    <tr>
      <th><%= t('activerecord.attributes.company.name') %></th>
      <th colspan="6"></th>
    </tr>
  </thead>

  <tbody>
    <% @companies.each do |company| %>
      <tr>
        <td><%= company.name %></td>
        <td><%= link_to t('show'), company %></td>
        <td><%= link_to t('edit'), edit_company_path(company) %></td>
        <td><%= link_to t('destroy'), company, method: :delete, data: { confirm: t('confirm') } %></td>
        <td><%= link_to t('offices.index'), company_offices_path(company) %></td>
        <td><%= link_to t('employees.index'), company_employees_path(company) %></td>
        <td><%= link_to t('projects.index'), company_projects_path(company) %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to t('companies.new'), new_company_path %>

app/views/companies/new.html.erb
<% breadcrumb :new_company %>

<h1><%= t('.') %></h1>

<%= render 'form', company: @company %>

<%= link_to t('back'), companies_path %>

app/views/companies/show.html.erb
<% breadcrumb :company, @company %>

<p id="notice"><%= notice %></p>

<p>
  <strong><%= t('activerecord.attributes.company.name') %>:</strong>
  <%= @company.name %>
</p>

<p>
  <strong><%= t('activerecord.attributes.office.name') %>:</strong>
  <%= @company.offices.pluck(:name).join(',') %>
</p>

<p>
  <strong><%= t('activerecord.attributes.employee.name') %>:</strong>
  <%= @company.employees.pluck(:name).join(',') %>
</p>

<%= link_to t('edit'), edit_company_path(@company) %> |
<%= link_to t('back'), companies_path %>